#ifndef CYGONCE_HAL_PLATFORM_INTS_H
#define CYGONCE_HAL_PLATFORM_INTS_H
//==========================================================================
//
//      hal_platform_ints.h
//
//      HAL Interrupt and clock support
//
//#####ECOSGPLCOPYRIGHTBEGIN####
//## -------------------------------------------
//## This file is part of eCos, the Embedded Configurable Operating System.
//## Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//##
//## eCos is free software; you can redistribute it and/or modify it under
//## the terms of the GNU General Public License as published by the Free
//## Software Foundation; either version 2 or (at your option) any later version.
//##
//## eCos is distributed in the hope that it will be useful, but WITHOUT ANY
//## WARRANTY; without even the implied warranty of MERCHANTABILITY or
//## FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
//## for more details.
//##
//## You should have received a copy of the GNU General Public License along
//## with eCos; if not, write to the Free Software Foundation, Inc.,
//## 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//##
//## As a special exception, if other files instantiate templates or use macros
//## or inline functions from this file, or you compile this file and link it
//## with other works to produce a work based on this file, this file does not
//## by itself cause the resulting work to be covered by the GNU General Public
//## License. However the source code for this file must still be made available
//## in accordance with section (3) of the GNU General Public License.
//##
//## This exception does not invalidate any other reasons why a work based on
//## this file might be covered by the GNU General Public License.
//##
//## Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
//## at http://sources.redhat.com/ecos/ecos-license/
//## -------------------------------------------
//#####ECOSGPLCOPYRIGHTEND####
//#####DESCRIPTIONBEGIN####
//
// Author(s):    msalter
// Contributors: 
// Date:         2000-10-10
// Purpose:      Define Interrupt support
// Description:  The interrupt details for the INPHINITY are defined here.
// Usage:
//               #include <cyg/hal/hal_platform_ints.h>
//               ...
//              
//
//####DESCRIPTIONEND####
//
//==========================================================================


#define DEBUG_INT 0

// 1st level
//
#define CYGNUM_HAL_INTERRUPT_SSP3	0
#define CYGNUM_HAL_INTERRUPT_MSL	1
#define CYGNUM_HAL_INTERRUPT_USBH2	2
#define CYGNUM_HAL_INTERRUPT_USBH1	3
#define CYGNUM_HAL_INTERRUPT_KEY	4
#define CYGNUM_HAL_INTERRUPT_MSTICK	5
#define CYGNUM_HAL_INTERRUPT_PI2C	6
#define CYGNUM_HAL_INTERRUPT_UTIMER	7


#define CYGNUM_HAL_INTERRUPT_GPIO0	8
#define CYGNUM_HAL_INTERRUPT_GPIO1	9
#define CYGNUM_HAL_INTERRUPT_GPIO	10
#define CYGNUM_HAL_INTERRUPT_USB	11
#define CYGNUM_HAL_INTERRUPT_PMU	12
#define CYGNUM_HAL_INTERRUPT_I2S	13
#define CYGNUM_HAL_INTERRUPT_AC97	14
#define CYGNUM_HAL_INTERRUPT_USIM	15
#define CYGNUM_HAL_INTERRUPT_SSP2	16





#define CYGNUM_HAL_INTERRUPT_LCD	17
#define CYGNUM_HAL_INTERRUPT_I2C	18
#define CYGNUM_HAL_INTERRUPT_ICP	19
#define CYGNUM_HAL_INTERRUPT_STUART	20
#define CYGNUM_HAL_INTERRUPT_BTUART	21
#define CYGNUM_HAL_INTERRUPT_FFUART	22
#define CYGNUM_HAL_INTERRUPT_MMC	23
#define CYGNUM_HAL_INTERRUPT_SSP	24
#define CYGNUM_HAL_INTERRUPT_DMA	25
#define CYGNUM_HAL_INTERRUPT_TIMER0	26
#define CYGNUM_HAL_INTERRUPT_TIMER1	27
#define CYGNUM_HAL_INTERRUPT_TIMER2	28
#define CYGNUM_HAL_INTERRUPT_TIMER3	29
#define CYGNUM_HAL_INTERRUPT_HZ		30
#define CYGNUM_HAL_INTERRUPT_ALARM	31

// 2nd level
#define CYGNUM_HAL_INTERRUPT_GPIO2	(32+2)
#define CYGNUM_HAL_INTERRUPT_GPIO3	(32+3)
#define CYGNUM_HAL_INTERRUPT_GPIO4	(32+4)
#define CYGNUM_HAL_INTERRUPT_GPIO5	(32+5)
#define CYGNUM_HAL_INTERRUPT_GPIO6	(32+6)
#define CYGNUM_HAL_INTERRUPT_GPIO7	(32+7)
#define CYGNUM_HAL_INTERRUPT_GPIO8	(32+8)
#define CYGNUM_HAL_INTERRUPT_GPIO9	(32+9)
#define CYGNUM_HAL_INTERRUPT_GPIO10	(32+10)
#define CYGNUM_HAL_INTERRUPT_GPIO11	(32+11)
#define CYGNUM_HAL_INTERRUPT_GPIO12	(32+12)
#define CYGNUM_HAL_INTERRUPT_GPIO13	(32+13)
#define CYGNUM_HAL_INTERRUPT_GPIO14	(32+14)
#define CYGNUM_HAL_INTERRUPT_GPIO15	(32+15)
#define CYGNUM_HAL_INTERRUPT_GPIO16	(32+16)
#define CYGNUM_HAL_INTERRUPT_GPIO17	(32+17)
#define CYGNUM_HAL_INTERRUPT_GPIO18	(32+18)
#define CYGNUM_HAL_INTERRUPT_GPIO19	(32+19)
#define CYGNUM_HAL_INTERRUPT_GPIO20	(32+20)
#define CYGNUM_HAL_INTERRUPT_GPIO21	(32+21)
#define CYGNUM_HAL_INTERRUPT_GPIO22	(32+22)
#define CYGNUM_HAL_INTERRUPT_GPIO23	(32+23)
#define CYGNUM_HAL_INTERRUPT_GPIO24	(32+24)
#define CYGNUM_HAL_INTERRUPT_GPIO25	(32+25)
#define CYGNUM_HAL_INTERRUPT_GPIO26	(32+26)
#define CYGNUM_HAL_INTERRUPT_GPIO27	(32+27)
#define CYGNUM_HAL_INTERRUPT_GPIO28	(32+28)
#define CYGNUM_HAL_INTERRUPT_GPIO29	(32+29)
#define CYGNUM_HAL_INTERRUPT_GPIO30	(32+30)
#define CYGNUM_HAL_INTERRUPT_GPIO31	(32+31)

#define CYGNUM_HAL_INTERRUPT_GPIO32	(64+0)
#define CYGNUM_HAL_INTERRUPT_GPIO33	(64+1)
#define CYGNUM_HAL_INTERRUPT_GPIO34	(64+2)
#define CYGNUM_HAL_INTERRUPT_GPIO35	(64+3)
#define CYGNUM_HAL_INTERRUPT_GPIO36	(64+4)
#define CYGNUM_HAL_INTERRUPT_GPIO37	(64+5)
#define CYGNUM_HAL_INTERRUPT_GPIO38	(64+6)
#define CYGNUM_HAL_INTERRUPT_GPIO39	(64+7)
#define CYGNUM_HAL_INTERRUPT_GPIO40	(64+8)
#define CYGNUM_HAL_INTERRUPT_GPIO41	(64+9)
#define CYGNUM_HAL_INTERRUPT_GPIO42	(64+10)
#define CYGNUM_HAL_INTERRUPT_GPIO43	(64+11)
#define CYGNUM_HAL_INTERRUPT_GPIO44	(64+12)
#define CYGNUM_HAL_INTERRUPT_GPIO45	(64+13)
#define CYGNUM_HAL_INTERRUPT_GPIO46	(64+14)
#define CYGNUM_HAL_INTERRUPT_GPIO47	(64+15)
#define CYGNUM_HAL_INTERRUPT_GPIO48	(64+16)
#define CYGNUM_HAL_INTERRUPT_GPIO49	(64+17)
#define CYGNUM_HAL_INTERRUPT_GPIO50	(64+18)
#define CYGNUM_HAL_INTERRUPT_GPIO51	(64+19)
#define CYGNUM_HAL_INTERRUPT_GPIO52	(64+20)
#define CYGNUM_HAL_INTERRUPT_GPIO53	(64+21)
#define CYGNUM_HAL_INTERRUPT_GPIO54	(64+22)
#define CYGNUM_HAL_INTERRUPT_GPIO55	(64+23)
#define CYGNUM_HAL_INTERRUPT_GPIO56	(64+24)
#define CYGNUM_HAL_INTERRUPT_GPIO57	(64+25)
#define CYGNUM_HAL_INTERRUPT_GPIO58	(64+26)
#define CYGNUM_HAL_INTERRUPT_GPIO59	(64+27)
#define CYGNUM_HAL_INTERRUPT_GPIO60	(64+28)
#define CYGNUM_HAL_INTERRUPT_GPIO61	(64+29)
#define CYGNUM_HAL_INTERRUPT_GPIO62	(64+30)
#define CYGNUM_HAL_INTERRUPT_GPIO63	(64+31)

#define CYGNUM_HAL_INTERRUPT_GPIO64	(96+0)
#define CYGNUM_HAL_INTERRUPT_GPIO65	(96+1)
#define CYGNUM_HAL_INTERRUPT_GPIO66	(96+2)
#define CYGNUM_HAL_INTERRUPT_GPIO67	(96+3)
#define CYGNUM_HAL_INTERRUPT_GPIO68	(96+4)
#define CYGNUM_HAL_INTERRUPT_GPIO69	(96+5)
#define CYGNUM_HAL_INTERRUPT_GPIO70	(96+6)
#define CYGNUM_HAL_INTERRUPT_GPIO71	(96+7)
#define CYGNUM_HAL_INTERRUPT_GPIO72	(96+8)
#define CYGNUM_HAL_INTERRUPT_GPIO73	(96+9)
#define CYGNUM_HAL_INTERRUPT_GPIO74	(96+10)
#define CYGNUM_HAL_INTERRUPT_GPIO75	(96+11)
#define CYGNUM_HAL_INTERRUPT_GPIO76	(96+12)
#define CYGNUM_HAL_INTERRUPT_GPIO77	(96+13)
#define CYGNUM_HAL_INTERRUPT_GPIO78	(96+14)
#define CYGNUM_HAL_INTERRUPT_GPIO79	(96+15)
#define CYGNUM_HAL_INTERRUPT_GPIO80	(96+16)
#define CYGNUM_HAL_INTERRUPT_GPIO81	(96+17)
#define CYGNUM_HAL_INTERRUPT_GPIO82	(96+18)
#define CYGNUM_HAL_INTERRUPT_GPIO83	(96+19)
#define CYGNUM_HAL_INTERRUPT_GPIO84	(96+20)
#define CYGNUM_HAL_INTERRUPT_GPIO85	(96+21)
#define CYGNUM_HAL_INTERRUPT_GPIO86	(96+22)
#define CYGNUM_HAL_INTERRUPT_GPIO87	(96+23)
#define CYGNUM_HAL_INTERRUPT_GPIO88	(96+24)
#define CYGNUM_HAL_INTERRUPT_GPIO89	(96+25)
#define CYGNUM_HAL_INTERRUPT_GPIO90	(96+26)
#define CYGNUM_HAL_INTERRUPT_GPIO91	(96+27)
#define CYGNUM_HAL_INTERRUPT_GPIO92	(96+28)
#define CYGNUM_HAL_INTERRUPT_GPIO93	(96+29)
#define CYGNUM_HAL_INTERRUPT_GPIO94	(96+30)
#define CYGNUM_HAL_INTERRUPT_GPIO95	(96+31)

#define CYGNUM_HAL_INTERRUPT_GPIO96	(128+0)
#define CYGNUM_HAL_INTERRUPT_GPIO97	(128+1)
#define CYGNUM_HAL_INTERRUPT_GPIO98	(128+2)
#define CYGNUM_HAL_INTERRUPT_GPIO99	(128+3)
#define CYGNUM_HAL_INTERRUPT_GPIO100	(128+4)
#define CYGNUM_HAL_INTERRUPT_GPIO101	(128+5)
#define CYGNUM_HAL_INTERRUPT_GPIO102	(128+6)
#define CYGNUM_HAL_INTERRUPT_GPIO103	(128+7)
#define CYGNUM_HAL_INTERRUPT_GPIO104	(128+8)
#define CYGNUM_HAL_INTERRUPT_GPIO105	(128+9)
#define CYGNUM_HAL_INTERRUPT_GPIO106	(128+10)
#define CYGNUM_HAL_INTERRUPT_GPIO107	(128+11)
#define CYGNUM_HAL_INTERRUPT_GPIO108	(128+12)
#define CYGNUM_HAL_INTERRUPT_GPIO109	(128+13)
#define CYGNUM_HAL_INTERRUPT_GPIO110	(128+14)
#define CYGNUM_HAL_INTERRUPT_GPIO111	(128+15)
#define CYGNUM_HAL_INTERRUPT_GPIO112	(128+16)
#define CYGNUM_HAL_INTERRUPT_GPIO113	(128+17)
#define CYGNUM_HAL_INTERRUPT_GPIO114	(128+18)
#define CYGNUM_HAL_INTERRUPT_GPIO115	(128+19)
#define CYGNUM_HAL_INTERRUPT_GPIO116	(128+20)
#define CYGNUM_HAL_INTERRUPT_GPIO117	(128+21)
#define CYGNUM_HAL_INTERRUPT_GPIO118	(128+22)
#define CYGNUM_HAL_INTERRUPT_GPIO119	(128+23)
#define CYGNUM_HAL_INTERRUPT_GPIO120	(128+24)
#define CYGNUM_HAL_INTERRUPT_GPIO121	(128+25)
#define CYGNUM_HAL_INTERRUPT_GPIO122	(128+26)
#define CYGNUM_HAL_INTERRUPT_GPIO123	(128+27)
#define CYGNUM_HAL_INTERRUPT_GPIO124	(128+28)
#define CYGNUM_HAL_INTERRUPT_GPIO125	(128+29)
#define CYGNUM_HAL_INTERRUPT_GPIO126	(128+30)
#define CYGNUM_HAL_INTERRUPT_GPIO127	(128+31)

externC void cyg_hal_xscale_soft_reset(CYG_ADDRESS);
#define HAL_PLATFORM_RESET()	cyg_hal_xscale_soft_reset(HAL_PLATFORM_RESET_ENTRY);

#define HAL_PLATFORM_RESET_ENTRY 0x00000000

// *** remainder are reserved  ****
#define CYGNUM_HAL_INT_

#define CYGNUM_HAL_ISR_MIN               0
#define CYGNUM_HAL_ISR_MAX               48

#define CYGNUM_HAL_ISR_COUNT            (CYGNUM_HAL_ISR_MAX + 1)

// The vector used by the Real time clock
#define CYGNUM_HAL_INTERRUPT_RTC        CYGNUM_HAL_INTERRUPT_TIMER
//#define CYGNUM_HAL_INTERRUPT_RTC        CYGNUM_HAL_INTERRUPT_PMU_CCNT_OVFL

extern void hal_delay_us(cyg_uint32 usecs);

#define HAL_DELAY_US(n)          hal_delay_us(n);

#endif // CYGONCE_HAL_PLATFORM_INTS_H
