
#define	SNO_WRITE_SCRATCHPAD		0x0f
#define SNO_READ_SCRATCHPAD		0xaa
#define SNO_COPY_SCRATCHPAD		0x55
#define SNO_READ_MEMORY			0xf0
#define SNO_WRITE_APPLICATION_REG	0x99
#define SNO_READ_STATUS_REG		0x66
#define SNO_READ_APPLICATION_REG	0xc3
#define SNO_COPY_LOCK			0x5a
#define SNO_READ_ROM			0x33
#define SNO_MATCH_ROM			0x55
#define SNO_SKIP_ROM			0xcc
#define SNO_SEARCH_ROM			0xf0

int reset_1w(void)
{
	int fu_result;

	asm volatile (
		      "ldr r4, =0x00000020;"	// mask for GPIO 5

		      "ldr r5, =0x40e0000c;"	// pin dir register
		      "ldr r6, [r5];"
		      "orr r6, r6, r4;"
		      "str r6, [r5];"		// set GPIO to output

		      "ldr r5, =0x40e00024;"	// output clear register
		      "str r4, [r5];"		// reset pin

		      "ldr r5, =0x40a00010;"	// timer 500 usec
		      "ldr r6, [r5];"
		      "ldr r7, =1800;"
		      "adc r6, r6, r7;"

		      "112:;"
		      "ldr r7, [r5];"
		      "cmp r7, r6;"
		      "bls 112b;"

		      "ldr r5, =0x40e00018;"	// output set register
		      "str r4, [r5];"		// reset pin

		      "ldr r5, =0x40e0000c;"	// pin dir register
		      "ldr r6, [r5];"
		      "bic r6, r6, r4;"
		      "str r6, [r5];"		// set GPIO to input

		      "ldr r5, =0x40a00010;"	// timer 80 usec
		      "ldr r6, [r5];"
		      "ldr r7, =288;"
		      "adc r6, r6, r7;"

		      "113:;"
		      "ldr r7, [r5];"
		      "cmp r7, r6;"
		      "bls 113b;"

		      "ldr r5, =0x40e00000;"	// pin level register
		      "ldr r6, [r5];"
		      "and r6, r6, r4;"
		      "mov %0, r6, lsr#5;"	// shift right by 5

		      "ldr r5, =0x40a00010;"	// timer 500 usec
		      "ldr r6, [r5];"
		      "ldr r7, =1800;"
		      "adc r6, r6, r7;"

		      "114:;"
		      "ldr r7, [r5];"
		      "cmp r7, r6;"
		      "bls 114b;"

		      : "=r"(fu_result)
		      :
		      : "r4","r5","r6","r7");

	return fu_result;
}

int sno_read(void)
{
	int fu_result;

	asm volatile (
		      "ldr r4, =0x00000020;"	// mask for GPIO 5

		      "ldr r5, =0x40e0000c;"	// pin dir register
		      "ldr r6, [r5];"
		      "orr r6, r6, r4;"
		      "str r6, [r5];"		// set GPIO to output

		      "ldr r5, =0x40e00024;"	// output clear register
		      "str r4, [r5];"		// reset pin

		      "ldr r5, =0x40a00010;"	// timer 5 usec
		      "ldr r6, [r5];"
		      "adc r6, r6, #18;"

		      "112:;"
		      "ldr r7, [r5];"
		      "cmp r7, r6;"
		      "bls 112b;"

		      "ldr r5, =0x40e00018;"	// output set register
		      "str r4, [r5];"		// reset pin

		      "ldr r5, =0x40e0000c;"	// pin dir register
		      "ldr r6, [r5];"
		      "bic r6, r6, r4;"
		      "str r6, [r5];"		// set GPIO to input

		      "ldr r5, =0x40a00010;"	// timer 5 usec
		      "ldr r6, [r5];"
		      "adc r6, r6, #18;"

		      "113:;"
		      "ldr r7, [r5];"
		      "cmp r7, r6;"
		      "bls 113b;"

		      "ldr r5, =0x40e00000;"	// pin level register
		      "ldr r6, [r5];"
		      "and r6, r6, r4;"
		      "mov %0, r6, lsr#5;"	// shift right by 5

		      : "=r"(fu_result)
		      :
		      : "r4","r5","r6","r7");

	return fu_result;
}

void sno_write_1(void)
{
	asm volatile (
		      "ldr r4, =0x00000020;"	// mask for GPIO 5

		      "ldr r5, =0x40e0000c;"	// pin dir register
		      "ldr r6, [r5];"
		      "orr r6, r6, r4;"
		      "str r6, [r5];"		// set GPIO to output

		      "ldr r5, =0x40e00024;"	// output clear register
		      "str r4, [r5];"		// reset pin

		      "ldr r5, =0x40a00010;"	// timer 5 usec
		      "ldr r6, [r5];"
		      "adc r6, r6, #18;"

		      "112:;"
		      "ldr r7, [r5];"
		      "cmp r7, r6;"
		      "bls 112b;"

		      "ldr r5, =0x40e00018;"	// output set register
		      "str r4, [r5];"		// reset pin

		      "ldr r5, =0x40e0000c;"	// pin dir register
		      "ldr r6, [r5];"
		      "bic r6, r6, r4;"
		      "str r6, [r5];"		// set GPIO to input

		      "ldr r5, =0x40a00010;"	// timer 60 usec
		      "ldr r6, [r5];"
		      "adc r6, r6, #214;"

		      "113:;"
		      "ldr r7, [r5];"
		      "cmp r7, r6;"
		      "bls 113b;"

		      :
		      :
		      : "r4","r5","r6","r7");
}

void sno_write_0(void)
{
	asm volatile (
		      "ldr r4, =0x00000020;"	// mask for GPIO 5

		      "ldr r5, =0x40e0000c;"	// pin dir register
		      "ldr r6, [r5];"
		      "orr r6, r6, r4;"
		      "str r6, [r5];"		// set GPIO to output

		      "ldr r5, =0x40e00024;"	// output clear register
		      "str r4, [r5];"		// reset pin

		      "ldr r5, =0x40a00010;"	// timer 67 usec
		      "ldr r6, [r5];"
		      "adc r6, r6, #240;"

		      "112:;"
		      "ldr r7, [r5];"
		      "cmp r7, r6;"
		      "bls 112b;"

		      "ldr r5, =0x40e00018;"	// output set register
		      "str r4, [r5];"		// reset pin

		      "ldr r5, =0x40e0000c;"	// pin dir register
		      "ldr r6, [r5];"
		      "bic r6, r6, r4;"
		      "str r6, [r5];"		// set GPIO to input

		      :
		      :
		      : "r4","r5","r6","r7");
}

void sno_write_byte (unsigned char sbyte)
{
	unsigned char mask;
	int i;

	mask = 0x01;
	for (i = 0; i < 8; i++) {
		if (sbyte & mask) {
			sno_write_1();
		} else {
			sno_write_0();
		}
		mask <<= 1;
		HAL_DELAY_US(1);
	}
}

unsigned char sno_read_byte (void)
{
	unsigned char mask = 0x01;
	unsigned char abyte = 0x00;
	unsigned char return_value;
	int i;

	for (i = 0; i < 8; i++) {
		return_value = sno_read();
		if (return_value) {
			abyte |= mask;
		}
		HAL_DELAY_US(80);
		mask <<= 1;
	}
	return abyte;
}

unsigned char sno_crc8(unsigned char * data, unsigned long count)
{
	unsigned char look_up_table[256] = {
		0, 94, 188, 226, 97, 63, 221, 131, 194, 156, 126, 32, 163, 253, 31, 65,
		157, 195, 33, 127, 252, 162, 64, 30, 95, 1, 227, 189, 62, 96, 130, 220,
		35, 125, 159, 193, 66, 28, 254, 160, 225, 191, 93, 3, 128, 222, 60, 98,
		190, 224, 2, 92, 223, 129, 99, 61, 124, 34, 192, 158, 29, 67, 161, 255,
		70, 24, 250, 164, 39, 121, 155, 197, 132, 218, 56, 102, 229, 187, 89, 7,
		219, 133, 103, 57, 186, 228, 6, 88, 25, 71, 165, 251, 120, 38, 196, 154,
		101, 59, 217, 135, 4, 90, 184, 230, 167, 249, 27, 69, 198, 152, 122, 36,
		248, 166, 68, 26, 153, 199, 37, 123, 58, 100, 134, 216, 91, 5, 231, 185,
		140, 210, 48, 110, 237, 179, 81, 15, 78, 16, 242, 172, 47, 113, 147, 205,
		17, 79, 173, 243, 112, 46, 204, 146, 211, 141, 111, 49, 178, 236, 14, 80,
		175, 241, 19, 77, 206, 144, 114, 44, 109, 51, 209, 143, 12, 82, 176, 238,
		50, 108, 142, 208, 83, 13, 239, 177, 240, 174, 76, 18, 145, 207, 45, 115,
		202, 148, 118, 40, 171, 245, 23, 73, 8, 86, 180, 234, 105, 55, 213, 139,
		87, 9, 235, 181, 54, 104, 138, 212, 149, 203, 41, 119, 244, 170, 72, 22,
		233, 183, 85, 11, 136, 214, 52, 106, 43, 117, 151, 201, 74, 20, 246, 168,
		116, 42, 200, 150, 21, 75, 169, 247, 182, 232, 10, 84, 215, 137, 107, 53};
	int i;
	unsigned char crc = 0;

	for (i = 0; i < count; i++) {
		crc = look_up_table[crc ^ data[i]];
	}
	return crc;
}

int sno_reset(void)
{
	int result;

	result = reset_1w();
	if (!result) {
		//diag_printf("presence pulse detected\n");
		return 0;
	} else {
		diag_printf("NO presence pulse detected\n");
		return 1;
	}
}

cyg_bool get_esa_1w(cyg_uint8 *buffer)
{
	int i;
	unsigned char mac_data[8] = {0x00,0x00,0x0c,0xc6,0x00,0x00,0x00,0x00};
	unsigned char crc, status;

	asm volatile (
		      "ldr r4, =0x00000020;"	// mask for GPIO 5
		      "ldr r7, =0x00000040;"	// mask for GPIO 6

		      "ldr r5, =0x40e0000c;"	// pin dir register
		      "ldr r6, [r5];"
		      "orr r6, r6, r4;"
		      "orr r6, r6, r7;"

		      "str r6, [r5];"		// set GPIO to output

		      "ldr r5, =0x40e00024;"	// output clear register
		      "str r4, [r5];"		// reset pin

		      "ldr r5, =0x40e00018;"	// output set register
		      "str r7, [r5];"		// set pin

		      "ldr r5, =0x40e0000c;"	// pin dir register
		      "ldr r6, [r5];"
		      "bic r6, r6, r4;"
		      "str r6, [r5];"		// set GPIO to input

		      "ldr r4, =0x00003c00;"
		      "ldr r5, =0x40e00054;"	// alternate function register
		      "ldr r6, [r5];"
		      "bic r6, r6, r4;"
		      "str r6, [r5];"		// set GPIO to IO function
		      :
		      :
		      : "r4","r5","r6","r7"
		      );

	HAL_DELAY_US(2000);			// 2 msec recovery time

	// check status of application register

	if (sno_reset()) {
		diag_printf("no eeprom device for MAC address found \n");
		return 0;
	}

	sno_write_byte(SNO_SKIP_ROM);
	sno_write_byte(SNO_READ_STATUS_REG);
	sno_write_byte(0x00);						// validation key
	status = sno_read_byte();
	//diag_printf("Status des Application Registers ist: %02X\n", status);

	if (sno_reset()) {
		diag_printf("no eeprom device for MAC address found \n");
		return 0;
	}

	if (status & 0x03) {
		diag_printf("No information in Application Register !!!!\n");
		diag_printf("using defauft MAC 0x00 : 0x0C : 0xC6 : 0x00 : 0x00 : 0x00\n");
		for (i = 0; i < 6; i++) {
			buffer[i] = mac_data[i+1];
		}
		return 1;
	}

	sno_write_byte(SNO_SKIP_ROM);
	sno_write_byte(SNO_READ_APPLICATION_REG);
	sno_write_byte(0x00);						// register address
	for (i = 0; i < 8;i++) {
		mac_data[i] = sno_read_byte();
	}

	if (sno_reset()) {
		diag_printf("no eeprom device for MAC address found \n");
		return 0;
	}

//	diag_printf("\nMAC address read from ROM: ");
//	for (i=0; i<8; i++) {
//		diag_printf("0x%02X ", mac_data[i]);
//	}
	diag_printf("\n");

	crc = sno_crc8(mac_data,7);

	//diag_printf("calculated CRC is: %02X\n", crc );

	if (crc != mac_data[7]) {
		diag_printf("ROM data CRC Checksum Error !!!\n\n");
		return 0;
	}

	for (i = 0; i < 6; i++)
		buffer[i] = mac_data[i + 1];

	return 1;
}
